using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Runtime.InteropServices;


namespace cpu
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            
        }
        [DllImport("USER32.DLL")]
        public static extern int FindWindow(
            int hWnd, String lpText        );
        [DllImport("USER32.DLL")]
        public static extern void PostMessage(
            int hWnd, int com,int wp,int lp);
        int wp = 0;
        int lp = 0;
        
        
        int a_port_address=0;
        int b_port_address=0;
        int write_port_address=0;
        int current_pc=0;
        uint clock = 0;

        uint regfile_R0 = 0;
        uint regfile_PORT = 0;
        uint regfile_R1 = 0;
        uint regfile_a_port=0;
        uint regfile_b_port=0;
        uint regfile_write_port=0;
        uint alu_port_a=0;
        uint alu_port_b=0;
        uint alu_out_port=0;
        uint loop_counter=0xffffffff;
        uint alu_operation = 0;
        uint alu_jump_cond = 0;

        string get_register_name(int num)
        {
            switch (num)
            {
                case (0): return "[";
                case (1): return "R0";
                case (2): return "R1";
                case (3): return "|[g";
                
            }
            return "";

        }

        private void make_code()
        {
            int command = (lp >> 28 ) & 0xf;
            int address = wp - 256;
            if (address == 0)
            {

                checkedListBox1.Items.Clear();
                clock = 0;
                
            }
           


            int a_port_address=(lp >>26) & 3 ;
            int b_port_address = (lp >> 24) & 3;
            int write_port_address=(lp>>22) & 3;
            int jump_cond = (lp >> 19) & 7;
            int loop_flag = (lp >> 16) & 1;
            uint immediate =(uint)( lp & 0xffff);
            string str;
            str =address.ToString("d4");
            str +=" : ";
            if (lp == 0)
            {

                str +="NOP";   
                checkedListBox1.Items.Add(str);
            }
            else if (command == 0)//Add
            {

                if (a_port_address == 0 && b_port_address == 0)//CLR
                {
                    string str_word = str+get_register_name(write_port_address);
                    str_word += "NA";
                     checkedListBox1.Items.Add(str_word);

                }else if (b_port_address == 0)//MOV
                {
                    string str_word = str+get_register_name(a_port_address);
                    str_word += "";
                    str_word += get_register_name(write_port_address);
                    str_word += "ւ̃Rs[";
                    checkedListBox1.Items.Add(str_word);

                }
                else
                {//Add

                    string str_word =str+ get_register_name(write_port_address);
                    str_word += " <= ";
                    str_word += get_register_name(a_port_address);
                    str_word += " + ";
                    str_word += get_register_name(b_port_address);
                    if (loop_flag == 1) str_word += " ,[vt";
                    checkedListBox1.Items.Add(str_word);

                }
            }
            else if (command == 1)//load IM
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += "";
                str_word += immediate.ToString("d");
                str_word += "dec , ";
                str_word += immediate.ToString("X");
                str_word += "hex[h";
               
                checkedListBox1.Items.Add(str_word);

            }
            else if (command == 2)//SUB
            {

                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(a_port_address);
                str_word += " - ";
                str_word += get_register_name(b_port_address);

                checkedListBox1.Items.Add(str_word);
                

            }
            else if (command == 3)//
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(b_port_address);
                str_word += " >> 1 ";
                if (loop_flag == 1) str_word += " ,[vt";


                checkedListBox1.Items.Add(str_word);

            }
            else if (command == 4)//
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(b_port_address);
                str_word += " << 1 ";
                if (loop_flag == 1) str_word += " ,[vt";
                checkedListBox1.Items.Add(str_word);

            }
            else if (command == 5)//JUMP
            {
                string str_word = str  ;
                if (jump_cond==2) {//always
                                 
                    str_word += immediate.ToString("d");
                    str_word += "ԒnɃWv";
                    checkedListBox1.Items.Add(str_word);
                }else if (jump_cond==3) {//not always
                    str +="NOP";
                     checkedListBox1.Items.Add(str);
                }else {
                     str_word += get_register_name(a_port_address);
                     if (jump_cond == 0) str_word += " = ";
                     else if (jump_cond == 1) str_word += " != ";
                     else if (jump_cond == 4) str_word += " < ";
                     else if (jump_cond == 5) str_word += " > ";
                     else if (jump_cond == 6) str_word += " <= ";
                     else if (jump_cond == 7) str_word += " >= ";
                     str_word += get_register_name(b_port_address);
                     str_word += "Ȃ";
                     str_word += immediate.ToString("d");
                     str_word += "ԒnɃWv";
                     checkedListBox1.Items.Add(str_word);
                }
                
                

            }
            else if (command == 6)//Sync
            {

                string str_word = str ;
                str_word += "Sync҂";
               
                checkedListBox1.Items.Add(str_word);

            }
            else if (command == 7)//AND
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(a_port_address);
                str_word += " & ";
                str_word += get_register_name(b_port_address);
                if (loop_flag == 1) str_word += " ,[vt";
                checkedListBox1.Items.Add(str_word);
                

            }
            else if (command == 8)//OR
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(a_port_address);
                str_word += " | ";
                str_word += get_register_name(b_port_address);
                if (loop_flag == 1) str_word += " ,[vt";
                checkedListBox1.Items.Add(str_word);

                

            }
            else if (command == 9)//XOR
            {

                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(a_port_address);
                str_word += " ^ ";
                str_word += get_register_name(b_port_address);
                if (loop_flag == 1) str_word += " ,[vt";
                checkedListBox1.Items.Add(str_word);

            }
            else if (command == 10)//*
            {
                string str_word = str + get_register_name(write_port_address);
                str_word += " <= ";
                str_word += get_register_name(a_port_address);
                str_word += " * ";
                str_word += get_register_name(b_port_address);
                if (loop_flag == 1) str_word += " ,[vt";
                checkedListBox1.Items.Add(str_word);

            }
        }
        private void draw_values()
        {
            int address = wp - 256;
            if (address >= 0) make_code();
            else
            {
                switch (wp) {
                    case (0) :current_pc=lp;break;
                    case (1): regfile_a_port =(uint) lp; break;
                    case (2): regfile_b_port =(uint) lp; break;
                    case (3): regfile_write_port =(uint) lp; break;
                    case (7): alu_port_a = (uint)lp; break;
                    case (8): alu_port_b = (uint)lp; break;
                    case (9): alu_out_port = (uint)lp; break;
                    case (4): regfile_R0 = (uint)lp; break;
                    case (5): regfile_R1 = (uint)lp; break;
                    case (6): regfile_PORT = (uint)lp; break;
                    case (10): alu_operation = (uint)lp; break;
                    case (11): alu_jump_cond = (uint)lp; break;
                    case (12): loop_counter = (uint)lp; break;
                  
                }

            }
        }
        private void draw_alu(Graphics g,int x, int y)
        {
            Pen p = new Pen(Color.Black, 2);
             Point[] ps = {new Point(10+x, 30+y), new Point(220+x, 30+y), 
                    new Point(200+x, 130+y), new Point(30+x, 130+y)};
            //܂
            g.DrawPolygon(p, ps);

            string a_port_str = alu_port_a.ToString("X4");
            string b_port_str = alu_port_b.ToString("X4");
            string write_port_str = alu_out_port.ToString("X4");

            string alu_op_str = "Iy[V";
            switch (alu_operation)
            {
                case (0): alu_op_str += "Add"; break;
                case (2): alu_op_str += "Sub"; break;
                case (3): alu_op_str += " >> "; break;
                case (4): alu_op_str += " << "; break;
                case (5): alu_op_str += " Jump";
                    switch (alu_jump_cond)
                    {
                        case (0): alu_op_str += "if Eq"; break;
                        case (1): alu_op_str += "if Not Eq"; break;
                        case (2): alu_op_str += "Always"; break;
                        case (3): alu_op_str += "Always Not"; break;
                        case (4): alu_op_str += "if < "; break;
                        case (5): alu_op_str += "if > "; break;
                        case (6): alu_op_str += "if <= "; break;
                        case (7): alu_op_str += "if >= "; break;
                    }
                    break;
                case (7): alu_op_str += " & "; break;
                case (8): alu_op_str += " | "; break;
                case (9): alu_op_str += " ^ "; break;
                case (10): alu_op_str += " * "; break;

            }            
            Font objFont1 = new Font("lr oSVbN", 11);
            g.DrawString(a_port_str, objFont1, Brushes.Blue, 50+x, 30+y);
            g.DrawString(b_port_str, objFont1, Brushes.Blue, 150+x, 30+y);
            g.DrawString(write_port_str, objFont1, Brushes.Blue, 100+x, 110+y);
            g.DrawString(alu_op_str, objFont1, Brushes.Blue, 25 + x, 70 + y);



        }
        private void draw_regfile(Graphics g, int x, int y)
        {
            Pen p = new Pen(Color.Black, 2);
            Point[] ps = {new Point(10+x, 30+y), new Point(220+x, 30+y), 
                    new Point(220+x, 130+y), new Point(10+x, 130+y)};
            //܂
            g.DrawPolygon(p, ps);

            string a_port_str = regfile_a_port.ToString("X4");
            string b_port_str = regfile_b_port.ToString("X4");
            string write_port_str = regfile_write_port.ToString("X4");

            string regfile_zero_str = "E[W@=0";
            string regfile_R0_str =   "ER0      @="+regfile_R0.ToString("X4");
            string regfile_R1_str =   "ER1      @="+regfile_R1.ToString("X4");
            string regfile_Port_str = "E|[gW="+regfile_PORT.ToString("X4");

            Font objFont1 = new Font("lr oSVbN", 11);
            g.DrawString(a_port_str, objFont1, Brushes.Blue, 70, 140);
            g.DrawString(b_port_str, objFont1, Brushes.Blue, 180, 140);
            g.DrawString(write_port_str, objFont1, Brushes.Blue, 130, 60);




            g.DrawString(regfile_zero_str, objFont1, Brushes.Green, 50, 75);
            g.DrawString(regfile_R0_str, objFont1, Brushes.Green, 50, 90);
            g.DrawString(regfile_R1_str, objFont1, Brushes.Green, 50, 105);
            g.DrawString(regfile_Port_str, objFont1, Brushes.Green, 50, 120);

        }

        private void draw_pc(Graphics g, int x, int y)
        {
            Pen p = new Pen(Color.Black, 2);
            Point[] ps = {new Point(10+x, 10+y), new Point(140+x, 10+y), 
                    new Point(140+x, 40+y), new Point(10+x, 40+y)};
            //܂
            g.DrawPolygon(p, ps);
            Font objFont1 = new Font("lr oSVbN", 12);
            string str;
            str = "PC=";
            str += current_pc.ToString("d2");

            g.DrawString(str, objFont1, Brushes.Blue, 10, 20);
            string lc_str="LC=";
            lc_str += loop_counter.ToString("x4");
            Font objFont2 = new Font("lr oSVbN", 10);
            g.DrawString(lc_str, objFont2, Brushes.Blue, 80, 45);

            if (checkedListBox1.Items.Count > current_pc)
            {
                checkedListBox1.SetSelected(current_pc , true);
            }

            string clock_str = "Total "+clock.ToString("x4") +"Clocks";
            g.DrawString(clock_str, objFont1, Brushes.Brown, 145, 5);
        }


        private void paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen p = new Pen(Color.Black, 2);

            
            draw_regfile(g, 30, 30);
            g.DrawLine(p, 90, 160, 90, 230);
            g.DrawLine(p, 200, 160, 200, 230); 
           draw_alu(g,30,200);

           g.DrawLine(p, 150, 330, 150, 360);
           g.DrawLine(p, 150, 360, 290, 360);
           g.DrawLine(p, 290, 360, 290, 30);
           g.DrawLine(p, 290, 30, 150, 30);
           g.DrawLine(p, 150, 30, 150, 60);


        }
        protected override void WndProc(ref Message m)
        {
            const int WM_CLOSE = 0x0010;
            const int WM_ENDSESSION = 0x16;
            const int WM_SYSCOMMAND = 0x112;
            const int SC_CLOSE = 0xF060;
            const int WM_COMMAND = 0x111;
            const int WM_SIZE = 0x0005;
            switch (m.Msg)
            {
                case WM_ENDSESSION:
                    //OS̃Vbg_Eŕ悤ƂĂ
                    //Console.WriteLine("WM_ENDSESSION");
                    break;
                case WM_SYSCOMMAND:
                    //if (m.WParam.ToInt32() == SC_CLOSE)
                    //X{^ARg[j[́uvA
                    //Rg[{bNX̃_uNbNA
                    //Atl+F4Ȃǂɂ悤ƂĂ
                    // Console.WriteLine("SC_CLOSE");
                    break;
                case WM_CLOSE:
                    //Application.ExitȊOŕ悤ƂĂ
                    //Console.WriteLine("WM_CLOSE");
                    break;
                case WM_SIZE:
                    pictureBox1.Refresh();
                    pictureBox2.Refresh();
                    break;

                case WM_COMMAND:
                    wp = (int)m.WParam;
                    lp = (int)m.LParam;
                    clock++;
                    draw_values();
                    pictureBox1.Refresh();//ăh[ 
                    pictureBox2.Refresh();
                    
                    break;
            }

            base.WndProc(ref m);//basěɏȂƂ
            if (m.Msg==WM_COMMAND && wp == 0)//̌$stop̂ŁÃR}h͍Ōɑ邱
            {
                if (checkedListBox1.Items.Count > current_pc)
                {
                    if (checkedListBox1.GetItemChecked(current_pc))//Breakpoint`FbNOnȂ
                    {

                        m.Result = (IntPtr)(-1);//Mark As breakpoint

                    }
                }
            }
        }

        private void paint_picture_box2(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen p = new Pen(Color.Black, 2);

            draw_pc(g, 0, 0);
        }

        private void StepButton(object sender, EventArgs e)
        {
            const int WM_COMMAND = 0x111;

            int veritakwin_handle=FindWindow(0,"VeritakWin");
			if (veritakwin_handle !=0) {//VeritakWin݂Ȃ 
	    
				PostMessage(veritakwin_handle,WM_COMMAND,133,0);//GO@Command VeritakWinɑ
			   		
			}
        }

        private void checkedListBox1_double_click(object sender, MouseEventArgs e)
        {
            
        }

        private void Stop_Button_clicked(object sender, EventArgs e)
        {
            const int WM_COMMAND = 0x111;

            int veritakwin_handle = FindWindow(0, "VeritakWin");
            if (veritakwin_handle != 0)
            {//VeritakWin݂Ȃ 

                PostMessage(veritakwin_handle, WM_COMMAND, 134, 0);//GO@Command VeritakWinɑ

            }
        }

        private void Reload_and_go_Button_clicked(object sender, EventArgs e)
        {
            const int WM_COMMAND = 0x111;

            int veritakwin_handle = FindWindow(0, "VeritakWin");
            if (veritakwin_handle != 0)
            {//VeritakWin݂Ȃ 

                PostMessage(veritakwin_handle, WM_COMMAND, 153, 0);//GO@Command VeritakWinɑ

            }
        }
    }
}