`timescale 1ns/1ps
`ifdef GATE_SIM
`define CYCLE 26.92
`else
`define CYCLE 30
`endif
module test;
	
	reg clock=0;
	reg reset=0;
	reg [15:0] port_in_data=0;
	reg sync=0;
	integer counter=0;

	wire [15:0] port_out_data;

	always #(`CYCLE/2) clock=~clock;
	
	initial begin
		reset=1;
		#105;
		reset=0;
		#1000000;
		$finish;
	end

	task inc_port_in_data;//Jul.12.2006
		begin
			counter=counter+1;
			if (counter[0])		port_in_data=port_in_data+1;
		end
	endtask

	cpu cpu(.clock,.reset,.sync,.port_in_data,.port_out_data);

	always @(negedge clock) begin
		inc_port_in_data;//Jul.12.2006
		if (port_out_data==51) begin
			repeat( 100) begin
				@(negedge clock);
			end	
			sync=1;
			@(negedge clock);
			sync=0;
		end
	end
      localparam integer MB_YESNO=4;
	localparam integer MB_YES=6;
	localparam integer MB_NO=7;
	localparam integer TOP_MOST=32'h4_0000;
`ifndef GATE_SIM
	integer handle,i;
	reg [8*20:1] str;
	reg [31:0] data;
	integer result;
	parameter integer WM_COMMAND=32'h111;
	initial begin
	
		handle=$FindWindow("MyCPU");
		if (handle) begin
			
		end else begin :loop0
				result=$MessageBox("悤BVisual fobKN܂H","VeritakMessageBox",MB_YESNO | TOP_MOST );
				if (result==MB_YES)  begin
					$shell_execute("cpu");
					repeat(100) begin//Retry@LOOPG@Repeat until MyCPU is detected.
						$Sleep(100);//100ms wait
						handle=$FindWindow("MyCPU");
						if (handle) disable loop0;
					end
				end
		end
		if (handle) begin	
			$SendMessage(handle,WM_COMMAND,256,0);//ROM R[h𑗏o		
			for (i=0;i<32;i=i+1) begin
				data=cpu.rom.romdata(i);
				$SendMessage(handle,WM_COMMAND,i+256,data);
			end
			$MessageBox("GUȈł܂BKvȂMyCPUROMXgŁAu[N|Cgݒ肵ĂB̌OK{^ĂB","VeritakMessageBox");
		end	else begin
			//$MessageBox("MyCPUNł܂łB","VeritakMessageBox");

		end
	end
	always @(negedge clock) begin
	
		handle_7led=$FindWindow("7LED");
		if (handle_7led) begin :LED//݂̏Ԃ𑗏o
			reg [31:0] led_value={1'b0,decoder(port_out_data[15:12]),
						  1'b0,decoder(port_out_data[11:8]),
						  1'b0,decoder(port_out_data[7:4]),
						  1'b0,decoder(port_out_data[3:0])};
			     $SendMessage(handle_7led,WM_COMMAND,led_value,0);
		end
		handle=$FindWindow("MyCPU");
		if (handle) begin//݂̏Ԃ𑗏o
			//regfile
			     $SendMessage(handle,WM_COMMAND,1,cpu.rfile.out_dataA);
  			     $SendMessage(handle,WM_COMMAND,2,cpu.rfile.out_dataB);
			     $SendMessage(handle,WM_COMMAND,3,cpu.rfile.alu_data);
			     $SendMessage(handle,WM_COMMAND,4,cpu.rfile.r0);
 			     $SendMessage(handle,WM_COMMAND,5,cpu.rfile.r1);
 			     $SendMessage(handle,WM_COMMAND,6,cpu.rfile.port_reg);



   			    $SendMessage(handle,WM_COMMAND,7,cpu.ALU.portA);
			    $SendMessage(handle,WM_COMMAND,8,cpu.ALU.portB);
 			    $SendMessage(handle,WM_COMMAND,9,cpu.ALU.alu_out);
 			     $SendMessage(handle,WM_COMMAND,10,cpu.ALU.command);
 			     $SendMessage(handle,WM_COMMAND,11,cpu.ALU.jump_cond);
			     $SendMessage(handle,WM_COMMAND,12,cpu.loop_counter);
				//PC R}h̓Xgɑ
				result=$SendMessage(handle,WM_COMMAND,0,cpu.pc);
				if (result==-1) begin//u[NvGUI痈
					$stop;
				end
			
		end


	end

	integer handle_7led;
	initial begin 
	
				
		handle_7led=$FindWindow("7LED");//T	
	
			if (!handle_7led)begin :loop1
				result=$MessageBox("|[go͂7ZOgLEDplɏo͂܂H","VeritakMessageBox",MB_YESNO | TOP_MOST );
				if (result==MB_YES) begin
					$shell_execute("LED7SEG");//7ZOgLED𗧂グ
					repeat(100) begin//Œ100msPOO=10sec҂
						$Sleep(100);
				 		handle_7led=$FindWindow("7LED");//T
						if (handle_7led) disable loop1;//Eo	
					end	 
				end
			end
	end
`endif	

	function [6:0] decoder(input  [3:0] din);//7segment LED
      	case (din)
       	4'b0000 : decoder = 7'b1111110;
        	4'b0001 : decoder = 7'b0110000;
        	4'b0010 : decoder = 7'b1101101;
       	4'b0011 : decoder = 7'b1111001;
       	4'b0100 : decoder = 7'b0110011;
        	4'b0101 : decoder = 7'b1011011;
        	4'b0110 : decoder = 7'b1011111;
        	4'b0111 : decoder = 7'b1110000;
        	4'b1000 : decoder = 7'b1111111;
       	4'b1001 : decoder = 7'b1111011;
       	4'b1010 : decoder = 7'b1110111;
       	4'b1011 : decoder = 7'b0011111;
        	4'b1100 : decoder = 7'b1001110;
        	4'b1101 : decoder = 7'b0111101;
        	4'b1110 : decoder = 7'b1001111;
        	4'b1111 : decoder = 7'b1000111;
           endcase
	endfunction

endmodule